// mazeing.cpp : Defines the class behaviors for the application.
//

//    Version 1.0   1985
//
//    Copyright 1985 Geoff Graham - http://geoffg.net
//    This program is free software: you can redistribute it and/or modify it under the terms of the GNU General
//    Public License as published by the Free Software Foundation, either version 2 of the License, or (at your
//    option) any later version.
//
//    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
//    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
//    for more details.  You should have received a copy of the GNU General Public License along with this program.
//    If not, see <http://www.gnu.org/licenses/>.


#include "stdafx.h"
#include "mazeing.h"

#include "mainwnd.h"

#include "globals.h"
#include "myctl3d.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CMazeingApp

BEGIN_MESSAGE_MAP(CMazeingApp, CWinApp)
	//{{AFX_MSG_MAP(CMazeingApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CMazeingApp construction

CMazeingApp::CMazeingApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}



/////////////////////////////////////////////////////////////////////////////
// The one and only CMazeingApp object

CMazeingApp NEAR theApp;




/////////////////////////////////////////////////////////////////////////////
// CMazeingApp initialization

BOOL CMazeingApp::InitInstance()
{
	// create the main window
    pMainWnd = m_pMainWnd = new CMainWnd();
    m_pMainWnd->ShowWindow( m_nCmdShow );
    m_pMainWnd->UpdateWindow();
    
	switch(GetPrivateProfileInt("Window", "3DEffects", 99, "Mazeing.ini")) {
		case 99:	// first time through for the user
					WritePrivateProfileString("Window", "3DEffects", "1", "Mazeing.ini") ;
					FirstTimeThrough = 1 ;
		            // fall through
		case 1:		Ctl3dRegister() ;
		}
	
	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

#ifndef _DEBUG    
    srand((unsigned)GetTickCount()) ;
#endif

	return TRUE;
}





// clean up on exiting the application
BOOL CMazeingApp::ExitInstance()
{
	Ctl3dUnRegister() ;
	return CWinApp::ExitInstance();
}




/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};




CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}




void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}




BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




// App command to run the dialog
void CMazeingApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}





/////////////////////////////////////////////////////////////////////////////
// CMazeingApp commands


// when windows is idle we can perform some calculations !
// for interest... some timing tests
//              1.0 sec = do all interations at once (no multitasking)
//              1.2 sec = do 6 interations each time
//              1.3 sec = do 4 interations each time
//              2.0 sec = do 1 interation each time
BOOL CMazeingApp::OnIdle(LONG lCount)
{

    int bMore = CWinApp::OnIdle(lCount);        // do MFC tasks
	if(bMore) return bMore ;                      // and do all of them first

	if(ValidMaze && MouseOnTrack)
		SetCursor(PencilCursor) ;

	if(MazeGenMode > MAX_GEN_MODE) {
		if(ValidCalcCancelDlg) {
			pMainWnd->EnableWindow(TRUE) ;
			CalcCancel.DestroyWindow() ;
			ValidCalcCancelDlg = 0 ;
			}
		if(FirstTimeThrough) {
			FirstTimeThrough = 0 ;
			WinHelp(0L, HELP_CONTENTS) ;
			}
		return 0 ;              // skip if not calculating a maze 
		}
		
	for(int i = 0 ; i < 4 ; i++)
		MazeOnIdle() ;  // do 4 maze interations at a time 
		
#ifdef SHOWTRACE        
	m_pMainWnd->Invalidate(FALSE) ; // show tracks
#endif

	return 1 ;              
}
